# encoding: utf8

class Caja :
	def __init__( self, xmin, ymin, xmax, ymax ) :
		self.xmin = xmin
		self.ymin = ymin
		self.xmax = xmax
		self.ymax = ymax

	def dibuja( self, arch ) :
		s = str(self.xmin) + " " + str(self.ymin) + "\n" 
		arch.write( s )

		s = str(self.xmax) + " " + str(self.ymin) + "\n" 
		arch.write( s )

		s = str(self.xmax) + " " + str(self.ymax) + "\n" 
		arch.write( s )
		
		s = str(self.xmin) + " " + str(self.ymax) + "\n" 
		arch.write( s )

		s = str(self.xmin) + " " + str(self.ymin) + "\n\n" 
		arch.write( s )

	def translada( self, x ) :
		self.xmin += x
		self.xmax += x

	# Prueba de la colisión caja contra caja
	def prueba( self, caja ) :
		if self.xmin > caja.xmax or self.xmax < caja.xmin :
			return 0
		
		return 1

class Plano :
	def __init__( self, x, y, nx, ny ) :
		self.x = x
		self.y = y
		self.nx = nx
		self.ny = ny

	def distancia_al_punto( self, px, py ) :
		wx = px - self.x 	
		wy = py - self.y 	
		d = self.nx * wx + self.ny * wy
		return d

	def distancia( self, caja ) :
		d1 = self.distancia_al_punto( caja.xmin, caja.ymin )
		d2 = self.distancia_al_punto( caja.xmax, caja.ymax )

		# en 3D se debe regresar un vector
		if d1 < d2 :
			return abs(d1)*self.nx
		else :
			return abs(d2)*self.nx
		
